#ifndef _TIMER2_																			//    
#define _TIMER2_

#ifndef F_CPU
# warning "F_CPU not defined. Frequency by default 14.7456MHz"
#define F_CPU 14745600UL																	//     (     )
#endif

#include <avr/iom128.h>																		//  /
#include <avr/interrupt.h>																	//  

__volatile__ static char _LED_Time=0;														//    (0-/1-)

__volatile__ char _Latch=0;																	//    
__volatile__ char _Key_flags;																//   

__volatile__ static unsigned int _ShimPeriod[8]={0,0,0,0,0,0,0,0};							// 
__volatile__ static unsigned int _ShimPulse[8]={0,0,0,0,0,0,0,0};							//  
__volatile__ static unsigned int _ShimCount[8]={0,0,0,0,0,0,0,0};							//  
	
void _LED_Display_Shift(uint8_t SC, uint8_t RL);											//  

#ifdef TIMER2																				//  

uint8_t _LED_Timer_Count=0;																	//  

//====================      2 =====================
SIGNAL(TIMER2_COMP_vect)
{
//--------------------------     -----------------------------
	if (_Latch)
	{
		if ((PINA & (1<<PA3))==0) _Key_flags|=0x01;											//     
		if ((PINA & (1<<PA2))==0) _Key_flags|=0x02;
		if ((PINA & (1<<PA1))==0) _Key_flags|=0x04;
		if ((PINA & (1<<PA0))==0) _Key_flags|=0x08;
	}
	
//------------------------------     ---------------------------------
	if(_LED_Time!=0)																		//   
	{
		if(_LED_Timer_Count>=_LED_Time)														//   
		{
			_LED_Display_Shift(1,0);														//   1  
			_LED_Timer_Count=0;																// 
		}
		else _LED_Timer_Count++;															// 
	}

//--------------------------------    -----------------------------------
	if (_ShimPulse[0]!=0)
	{
		_ShimCount[0]++;																	//   
		if (_ShimCount[0]<_ShimPeriod[0])													//   
		{
			if (_ShimCount[0]>=_ShimPulse[0]) PORTB&=~(1<<PB4);								//     ,  
		}
		else
		{
			_ShimCount[0]=0;																//      
			PORTB|=(1<<PB4);																//   (  )
		}
	}
	if (_ShimPulse[1]!=0)
	{
		_ShimCount[1]++;																	//   
		if (_ShimCount[1]<_ShimPeriod[1])													//   
		{
			if (_ShimCount[1]>=_ShimPulse[1]) PORTB&=~(1<<PB5);								//     ,  
		}
		else
		{
			_ShimCount[1]=0;																//      
			PORTB|=(1<<PB5);																//   (  )
		}
	}
	if (_ShimPulse[2]!=0)
	{
		_ShimCount[2]++;																	//   
		if (_ShimCount[2]<_ShimPeriod[2])													//   
		{
			if (_ShimCount[2]>=_ShimPulse[2]) PORTB&=~(1<<PB6);								//     ,  
		}
		else
		{
			_ShimCount[2]=0;																//      
			PORTB|=(1<<PB6);																//   (  )
		}
	}
	if (_ShimPulse[3]!=0)
	{
		_ShimCount[3]++;																	//   
		if (_ShimCount[3]<_ShimPeriod[3])													//   
		{
			if (_ShimCount[3]>=_ShimPulse[3]) PORTB&=~(1<<PB7);								//     ,  
		}
		else
		{
			_ShimCount[3]=0;																//      
			PORTB|=(1<<PB7);																//   (  )
		}
	}
	if (_ShimPulse[4]!=0)
	{
		_ShimCount[4]++;																	//   
		if (_ShimCount[4]<_ShimPeriod[4])													//   
		{
			if (_ShimCount[4]>=_ShimPulse[4]) PORTD&=~(1<<PD4);								//     ,  
		}
		else
		{
			_ShimCount[4]=0;																//      
			PORTD|=(1<<PD4);																//   (  )
		}
	}
	if (_ShimPulse[5]!=0)
	{
		_ShimCount[5]++;																	//   
		if (_ShimCount[5]<_ShimPeriod[5])													//   
		{
			if (_ShimCount[5]>=_ShimPulse[5]) PORTD&=~(1<<PD5);								//     ,  
		}
		else
		{
			_ShimCount[5]=0;																//      
			PORTD|=(1<<PD5);																//   (  )
		}
	}
	if (_ShimPulse[6]!=0)
	{
		_ShimCount[6]++;																	//   
		if (_ShimCount[6]<_ShimPeriod[6])													//   
		{
			if (_ShimCount[6]>=_ShimPulse[6]) PORTD&=~(1<<PD6);								//     ,  
		}
		else
		{
			_ShimCount[6]=0;																//      
			PORTD|=(1<<PD6);																//   (  )
		}
	}
	if (_ShimPulse[7]!=0)
	{
		_ShimCount[7]++;																	//   
		if (_ShimCount[7]<_ShimPeriod[7])													//   
		{
			if (_ShimCount[7]>=_ShimPulse[7]) PORTD&=~(1<<PD7);								//     ,  
		}
		else
		{
			_ShimCount[7]=0;																//      
			PORTD|=(1<<PD7);																//   (  )
		}
	}		
}
	
//==============================    2 =================================
void _Timer2_Enable(void)
{
//	OCR2=36;																				//  10  (   3.6864 )
	OCR2=F_CPU*0.01/1024+0.5;																//  10 
	TIMSK|=(1<<OCIE2);																		//    2 
	TCCR2=(1<<WGM21)|(1<<CS22)|(1<<CS20);													//  2   "  ".   1024.
	sei();																					//  
}

#endif
#endif