/**********************************************************************************************************************************
 * Example_Menu_MC.c
 * : 19.08.2016
 *  :  -  II.
 *     Menu.h
 ***********************************************************************************************************************************/ 

#define F_CPU 14745600UL 																											//    
#define MAX_ELEMENTS_MENU 17																										//    
#define MAX_SUB_MENUS 8																												//  
#define MAX_HISTORY_ELEMENTS 16																										//  
#define MAX_HISTORY_NAMES 16																										//     


#include "MC4A7D4R4O.h"																												// 

#include <avr/io.h>																													//  /
#include <util/delay.h>																												//  
#include <avr/pgmspace.h>																											//      FLASH 
#include "Menu.h"																													//    MC
#include "LED.h"																													// 
#include "Key.h"																													// 

//====================================================  FLASH =========================================================//
uint8_t param1 = 1;																													// ""  1  0
uint8_t param2[5] = {'1','1','1','1','1'};																							//   11111,     0  99999
	
uint8_t param3[5] = {'2','2','.','2','2'};																							//   22.22,     0  99999
uint8_t param4[] = {""};																									//   ""
	
uint8_t param5 = 0;																													// ""  1  0
uint8_t param6[5] = {'3','3','3','3','3'};																							//   33333,     0  99999

uint8_t param7 = 1;																													// ""  1  0
uint8_t param8[6] = {'-','4','4','4','4','4'};																						//   -44444,     -99999  +99999

//===================================================   ===========================================================//
int main(void)
{
	uint8_t buf[8];																													//,        
	uint8_t type = 0;																												//     
	uint16_t element = 0;																											//       
	
	LED_Init();																														// 
	
//----------------------------------------------------    ------------------------------------------------//
	//  (0 -  , 3 -  , NONE -   )
	Add_New_Menu(0, 3, NONE);																										//   
	//   (0 -   , 
	//						0 -    ,
	//						EMPTY_ELEMENT -  (  ), 
	//						1 -   , 
	//						" 1" -  , 
	//						NONE -    ( )
	Add_New_Element(0, 0, EMPTY_ELEMENT, 1, PSTR(" 1"), NONE);																	//   
	Add_New_Element(1, 1, EMPTY_ELEMENT, 2, PSTR(" 2"), NONE);
	Add_New_Element(2, 2, EMPTY_ELEMENT, 3, PSTR(" 3"), NONE);
	
	Add_New_Menu(1, 2, 0);																											//    ( 1    0)
	Add_New_Element(3, 0, EMPTY_ELEMENT, 4, PSTR(" 1/n  1"), NONE);
	Add_New_Element(4, 1, EMPTY_ELEMENT, 5, PSTR(" 2/n  1"), NONE);
	
	Add_New_Menu(2, 2, 0);																											//    ( 2    0)
	Add_New_Element(5, 0, EMPTY_ELEMENT, 6, PSTR(" 1/n  2"), NONE);
	Add_New_Element(6, 1, EMPTY_ELEMENT, 7, PSTR(" 2/n  2"), NONE);
	
	Add_New_Menu(3, 2, 0);																											//    ( 3    0)
	Add_New_Element(7, 0, DEFAULT_ELEMENT, NONE, PSTR("/n "), NONE);
	Add_New_Element(8, 1, EMPTY_ELEMENT, 8, PSTR("/n"), NONE);
	
	Add_New_Menu(4, 2, 1);																											//    ( 4    1)
	Add_New_Element(9, 0, SWITCH_ELEMENT, NONE, PSTR(".1 1"), &param1);
	Add_New_Element(10, 1, PARAM_ELEMENT, NONE, PSTR(".2 1"), param2);
	
	Add_New_Menu(5, 2, 1);																											//    ( 5    1)
	Add_New_Element(11, 0, PARAM_ELEMENT, NONE, PSTR(".3 1"), param3);
	Add_New_Element(12, 1, WORD_ELEMENT, NONE, PSTR(".4 1"), param4);
	
	Add_New_Menu(6, 2, 2);																											//    ( 6    2)
	Add_New_Element(13, 0, SWITCH_ELEMENT, NONE, PSTR(".1 2"), &param5);
	Add_New_Element(14, 1, PARAM_ELEMENT, NONE, PSTR(".2 2"), param6);
	
	Add_New_Menu(7, 2, 2);																											//    ( 7    2)
	Add_New_Element(15, 0, SWITCH_ELEMENT, NONE, PSTR(".3 2"), &param7);
	Add_New_Element(16, 1, PARAM_ELEMENT, NONE, PSTR(".4 2"), param8);
	
	Add_New_Menu(8, 1, 3);																											//    ( 8    3)
	Add_New_Element(17, 0, HISTORY_ELEMENT, NONE, PSTR(""), NONE);
	
	
    while (1) 
    {
//-----------------------------------------------   ---------------------------------------------------------------//
		LED_SetPos(0,0);
		LED_Write_String_P(PSTR(" "));																					//   
		LED_SetPos(1,0);
		LED_Write_String_P(PSTR(""));
		_delay_ms(200);	

//-----------------------------------------------    ----------------------------------------------------------------------//
		if (Key(0) == 1)																											//   0 
		{
			while(Key(0) == 1) {_delay_ms(10);}																						//   ()
				
			while (1)																												//  
			{
				element = Goto_Menu(buf, &type);																					//   ,      
				if (element != NONE)																								//   
				{
					if (element == EXIT) break;																						//    
					Save_Changes(element, buf);																						//  
				}
			}
		}
    }
}

